﻿using System;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace DeathsAdvance
{
    public class DeathsAdvance : HBPlugin
    {
        public static LocalPlayer Me = StyxWoW.Me;

        public override string Name => "Death's Advance";

        public override string Author => "Lbniese";

        public override Version Version => new Version(1, 0);

        public override bool WantButton => true;

        public override string ButtonText => "None";

        public override void OnEnable()
        {
            Logging.Write(Colors.Green, "Death's Advance - Enabled v" + Version + "!");
            base.OnEnable();
        }

        public override void OnDisable()
        {
            Logging.Write(Colors.Red, "Death's Advance - Disabled!");
            base.OnDisable();
        }

        public override void Pulse()
        {
            if (!StyxWoW.IsInGame
                || !StyxWoW.Me.IsAlive
                || !StyxWoW.Me.IsMoving
                //|| StyxWoW.Me.Combat
                || StyxWoW.Me.IsCasting
                || StyxWoW.Me.Mounted
                || StyxWoW.Me.IsOnTransport
                || StyxWoW.Me.OnTaxi
                || Me.IsSwimming
                || Me.HasAura(68992)
                || Me.HasAura(2983)
                || Me.HasAura(137573))
            {
                return;
            }

            if (SpellManager.HasSpell(96268) // Death's Advance
                && SpellManager.CanCast(96268) // Death's Advance
                && !Me.HasAura(96268)
                //&& !Me.HasAura(68992)
                //&& !Me.HasAura(2983)
                //&& !Me.HasAura(137573)
                )
            {
                SpellManager.Cast(96268);
                Logging.Write(Colors.BlueViolet, "Casted Death's Advance!");
            }
        }
    }
}